package com.spectus.iap.spectus_in_app_purchase

import androidx.annotation.NonNull
import io.flutter.embedding.engine.plugins.FlutterPlugin
import io.flutter.plugin.common.MethodCall
import io.flutter.plugin.common.MethodChannel
import io.flutter.plugin.common.MethodChannel.MethodCallHandler
import io.flutter.plugin.common.MethodChannel.Result
import io.flutter.plugin.common.PluginRegistry.Registrar
import android.content.Context

/** SpectusInAppPurchasePlugin */
class SpectusInAppPurchasePlugin: FlutterPlugin, MethodCallHandler{

 // private lateinit var channel : MethodChannel
  var helper : IAPHelper? = null
  var productID : String? = ""
  var mContext : Context? = null
  var operationResult : Result? = null

  override fun onAttachedToEngine(@NonNull flutterPluginBinding: FlutterPlugin.FlutterPluginBinding) {
    val channel = MethodChannel(flutterPluginBinding.getFlutterEngine().getDartExecutor(), "spectus_in_app_purchase")
    mContext = flutterPluginBinding.applicationContext
    channel.setMethodCallHandler(this)
  }

  companion object {
    @JvmStatic
    fun registerWith(registrar: Registrar) {
      val channel = MethodChannel(registrar.messenger(), "spectus_in_app_purchase")
      channel.setMethodCallHandler(SpectusInAppPurchasePlugin())
      //helper = IAPHelper()
    }
  }

  override fun onMethodCall(@NonNull call: MethodCall, @NonNull result: Result) {

      android.util.Log.e("onMethodCall"," "+call.method)

    if (call.method == "getPlatformVersion") {
      result.success("Android ${android.os.Build.VERSION.RELEASE}")
    } else if (call.method == "startInAppPurchaseWith") {
      productID = call.argument<String>("productID")
     // context = call.argument<Context>("context")
      operationResult = result
     android.util.Log.e("Productid"," "+productID)
     android.util.Log.e("helper"," "+helper)

        IAPHelper().startInAppPurchaseWith(mContext!!, productID!!, { error, purchaseObject, transactionID ->
        if (error != null) {
          operationResult!!.success("NA")
        }

        if (transactionID != null) {
          operationResult!!.success(transactionID)
        }
      })

      /*helper.startInAppPurchaseWith(mContext, productID, { error, purchaseObject, transactionID ->
        if (error != null) {
          operationResult!!.success("NA")
        }

        if (transactionID != null) {
          operationResult!!.success(transactionID)
        }
      })*/
    } else {
      result.notImplemented()
    }
  }

  override fun onDetachedFromEngine(@NonNull binding: FlutterPlugin.FlutterPluginBinding) {
  //  channel.setMethodCallHandler(null)
  }
}
